package biz.hammurapi.convert;

import biz.hammurapi.config.Context;

/**
 * Converts objects from one type to another, e.g. Integer to String.
 * @author Pavel
 *
 */
public interface Converter {

	/**
	 * Converts object to requested target type.
	 * @param source Source object.
	 * @param targetType Target type.
	 * @param context Conversion context.
	 * @return Converted object.
	 */
	Object convert(Object source, Class targetType, Context context) throws ConversionException;
}
