package biz.hammurapi.properties;

/**
 * Instantiates property sets.
 * @author Pavel
 */
public interface PropertySetFactory {

	/**
	 * Creates new property set.
	 * @param chain Property sets can be chained. Chaining allows to
	 * build hierarchies of property sets. New property set access operations
	 * delegate to chains if the property set itself does not contain requested
	 * values. All update and remove operations are local to the property
	 * set - chains are never modified.
	 * @return New property set.
	 */
	PropertySet createPropertySet(PropertySet[] chain);
}
